//prof. Sandor Nicoleta
#include <fstream>
using namespace std;
ifstream fin("prime.in");
ofstream fout("prime.out");

bool prim(int n)
{
    if (n<2) return 0;
    if(n==2) return 1;
    if(n%2==0) return 0;
    for(int d=3; d*d<=n; d=d+2)
        if(n%d==0)
            return 0;
    return 1;
}
bool fibo(int n)
{
    int a,b,c;
    a=b=c=1;
    while(c<n)
    {
        c=a+b;
        a=b;
        b=c;
    }
    return c==n;
}
int nrcif(long long n)
{
    int c=0;
    while(n)
    {
        n/=10;
        c++;
    }
    return c;
}
int descompun(long long x)
{
    int c,s=0;
    long long d=2;
    while(x > 1)
    {
        if(x % d == 0)
        {
            s+=nrcif(d);
            c=0;
            while(x % d == 0)
                x /= d,c++;
            if(c>1) s+=nrcif(c);
        }
        d ++;
        // daca x este numar prim ne oprim
        if(x > 1 && d * d > x)
        {
            s+=nrcif(x);
            x = 1;
        }
    }
    return s;
}
int main()
{
    int i,n,c,v[50],x=0, a;
    long long a1,j;
    fin>>c>>n;
    if(c==1)
    {
        for(i=0; i<n; i++)
        {
            fin>>a;
            if (fibo(a)&&prim(a))
                x++;
        }
        fout<<x;
    }
    else if(c==2)
    {
        for(i=0; i<n; i++)
        {
            fin>>a1;
            if (descompun(a1)<nrcif(a1))
                x++;
        }
        fout<<x;
    }
    else
    {
        x=n;
        for(i=0; i<n; i++)
        {
            fin>>a;
            if(n>3)
            {
                //orice numar par mai mare dcat 4 se poate scrie ca suma a doua numere prime
                if(a%2==0) x--;
                else if (prim(a-2))
                {
                    x--;
                }
            }
        }
        fout<<x;
    }
    return 0;
}
